window.ggj = {
	worlds:[],
	activeWorld:null,
	activeEnemy:null,
	players:{},
	livePlayerCount:0,
	tileSize:50,
	enemies:[],
	enemyTypes:[
		"bird", "bird", "bird", "bird", "bird", "bird", "bird", "bird", "bird", "bird", "bird", "bird", "bird", "bird", 
		"bird", "bird", "bird", "bird", "bird", "bird", "bird", "bird", "bird", "bird", "bird", "bird", "bird", "bird", 

		"bones", "bones", "bones", "bones", "bones", "bones", "bones", "bones", "bones", "bones", 
		"bones", "bones", "bones", "bones", "bones", "bones", "bones", "bones", "bones", "bones", 

		"bones2", "bones2", "bones2", "bones2", 

		"labatut"
		],		
	
World:function( name )
{
	ggj.worlds.push(this);
	var THIS = this;
	var node = this.node = new THREE.Object3D();
	var children = [];
	var tileEvents = {
		0:"collide"
	};
	var tileX = 0;
	var tileY = 0;
	var tiles = [];
	var floor;
	
	this.getTileContents = function( tile )
	{
		return tiles[ tile.y*tileX+tile.x ];
	};
	
	this.getEmptyTile = function()
	{
		var i=0;
		for( var t=0; t<1000; ++t )
		{
			i=Math.floor(Math.random()*tiles.length);
			if( tiles[i] === undefined )
				return {x: i%tileX, y:Math.floor(i/tileX), e:undefined};
		}
		return undefined;
	};
	
	this.activate = function(){
		if( ggj.activeWorld == this ) 
			return;
		
		if( ggj.activeWorld )
			ggj.activeWorld.deactivate();
		
		ggj.activeWorld = this;
		motor.gfx.scene.add( node );
		motor.gfx.addTick(this.onTick);
	};
	
	this.deactivate = function()
	{
		node.parent.remove(node);
		motor.gfx.removeTick(this.onTick);
	};
	
	var tmp = {x:0, y:0, e:null};
	this.onTick = function(time)
	{
		for( var i=0, n; n=children[i]; ++i )
			if( n.onTick )
			{
				if( n.tilePos )
				{
					tmp.e = n.tilePos.e;
					tmp.x = n.tilePos.x;
					tmp.y = n.tilePos.y;
				}
				else
				{
					tmp.y = tmp.x = undefined;
				}
				n.onTick(time);
				if( n.tilePos && (n.tilePos.x != tmp.x || n.tilePos.y != tmp.y) )
				{
					if( tmp.x != undefined )
					{
						var c = tmp.y*tileX + tmp.x;
						if( tiles[ c ] == n )
							tiles[ c ] = tmp.e;
						else if( tiles[ c ].tilePos && tiles[c].tilePos.e == n )
							tiles[ tmp.y*tileX + tmp.x ].tilePos.e = tmp.e;
					}
					n.tilePos.e = tiles[ n.tilePos.y*tileX + n.tilePos.x ];
					tiles[ n.tilePos.y*tileX + n.tilePos.x ] = n;
				}
			}
	};
	
	this.add = function( c )
	{
		if( children.indexOf(c) != -1 ) return;
		children.push(c);
		node.add(c.node);
	};
	
	this.remove = function( c )
	{
		var pos = children.indexOf(c);
		if( pos == -1 )
			return;
		
		if( c.tilePos )
			tiles[ c.tilePos.y*tileX + c.tilePos.x ] = c.tilePos.e;
		
		c.tilePos = null;
		children.splice( pos, 1 );
		
		if( c.node.parent )
			c.node.parent.remove(c.node);
	};
	
	(function(){
		var img = window[name + "Tilespng"];
		var canvas = document.createElement("canvas");
		tileX = canvas.width = img.width;
		tileY = canvas.height = img.height;
		var ctx = canvas.getContext('2d');
		ctx.drawImage(img, 0, 0, img.width, img.height);
		var data = ctx.getImageData(0, 0, img.width, img.height).data;
		var size = img.width*img.height;
		tiles = new Array(size);
		for( var i=0; i<size; ++i )
		{
			tiles[i] = tileEvents[data[i*4]&0xFFFFFF];
		}
		
		var geometry = new THREE.PlaneBufferGeometry(
			img.width * ggj.tileSize,
			img.height * ggj.tileSize,
			img.width,
			img.height
		);
		
		var texture = THREE.ImageUtils.loadTexture( window[name + "jpg"].src );
		texture.magFilter = THREE.NearestFilter;
		texture.minFilter = THREE.LinearMipMapLinearFilter;
		
		var mat = { map : texture };
		
		var material = new THREE.MeshLambertMaterial( mat );
		floor = new THREE.Mesh( geometry, material );
		floor.rotation.x = -Math.PI*0.5;
		floor.position.set( 
			img.width*ggj.tileSize*0.5-ggj.tileSize*0.5, 
			0, 
			img.height*ggj.tileSize*0.5-ggj.tileSize*0.5 
			);
		node.add( floor );
	})();
	
	main.worlds.push(this);
},

Player:function( number, characterMesh, objective, character )
{
	ggj.livePlayerCount++;
	ggj.players[number] = this;
	var node = this.node = new characterMesh.create();
	var world = this.world = null;
	var tilePos = this.tilePos = null;
	console.log( "A new challenger appears!");
	node.controller = this;
	node.rotation.y = Math.random()*Math.PI*2;

	if( character == "female" )
	{
		this.maxHealth = this.health = 7;
		this.maxStamina = this.stamina = 3;
		this.range = 3;
	}
	else if( character == "old" )
	{
		this.maxHealth = this.health = 6;
		this.maxStamina = this.stamina = 4;
		this.range = 2;
	}
	else if( character == "chainsaw" )
	{
		this.maxHealth = this.health = 8;
		this.maxStamina = this.stamina = 4;
		this.range = 1;
	}
	
	this.spendStamina = function(){
		this.stamina--;
		if( this.stamina <= 0 )
			main.next();
	};
	
	this.attack = function( target )
	{
		if( target == this )
			return;
		
		var tmp={x:target.tilePos.x-this.tilePos.x, y:target.tilePos.y-this.tilePos.y};
		var dist = Math.sqrt(tmp.x*tmp.x+tmp.y*tmp.y);
		if( this.range >= dist )
		{
			new Audio("snd/shot" + character + ".wav").play();
			node.rotation.y = Math.atan2(tmp.x, tmp.y);
			target.hit( this.damage );
		}
		else {
			tmp.x = Math.sign(tmp.x);
			tmp.y = Math.sign(tmp.y);
			if( tmp.x ) tmp.y = 0;
			if( !this.stamina )
			{
				targetScale = 1;
				return;
			}
			if( state ) 
				return;
		
			targetScale = 1.1;
			inter = 0;
			state = tmp;
			nextPos.x = tilePos.x + state.x;
			nextPos.y = tilePos.y + state.y;
			node.rotation.y = Math.atan2(state.x, state.y);
			if( world.getTileContents( nextPos ) !== undefined )
				state = null;
			else
				this.spendStamina();
		}			
	}
	
	this.hit = function( dmg )
	{
		this.health-=dmg;
		if( this.health > 0 )
			return;
		new Audio("snd/die" + character + ".wav").play();
		ggj.livePlayerCount--;
		this.world.remove(this);
		delete ggj.players[number];
		if( ggj.activePlayer == this )
			ggj.activePlayer = null;
	};
	
	this.activate = function()
	{
		motor.gfx.camera.target = this.node;
		if( ggj.activePlayer == this )
			return;
		if( ggj.activePlayer )
			ggj.activePlayer.deactivate();
		if( !this.world )
		{
			world = this.world = ggj.worlds[ Math.floor(Math.random()*ggj.worlds.length) ];
			world.add(this);
		}
		ggj.activePlayer = this;
		this.world.activate();
	};
	
	this.deactivate = function()
	{
		if( motor.gfx.camera.target == this.node )
			motor.gfx.camera.target = null;
	};

	var stateMap = {
		"left": {x:1, y:0},
		"right": {x:-1, y:0},
		"up": {x:0, y:1},
		"down": {x:0, y:-1}
	};
	
	var state = null;
	var targetScale=1;
	
	this.down = function(e)
	{
		if( state != null ) return;
		if( stateMap[e] ) targetScale = 0.8;
	};
	
	var nextPos = {x:0, y:0};
	var inter = 0;
	this.up = function(e)
	{
		if( !this.stamina )
		{
			targetScale = 1;
			return;
		}
		if( state || !stateMap[e] ) 
			return;
		
		targetScale = 1.1;
		inter = 0;
		state = stateMap[e];
		nextPos.x = tilePos.x + state.x;
		nextPos.y = tilePos.y + state.y;
		node.rotation.y = Math.atan2(state.x, state.y);
		if( world.getTileContents( nextPos ) !== undefined )
			state = null;
		else
			this.spendStamina();
	};
	
	this.onTick = function(time)
	{
		node.scale.y += (targetScale - node.scale.y) * time * 20;
		
		if( !this.tilePos )
		{
			this.tilePos = tilePos = world.getEmptyTile();
			this.node.position.set( tilePos.x*ggj.tileSize, 0, tilePos.y*ggj.tileSize );
		}
		
		if( !state ) return;
		
		inter += time * 4;
		if( inter > 1 )
		{
			inter = 1;
			state = null;
			tilePos.x = nextPos.x;
			tilePos.y = nextPos.y;
			targetScale = 1;
		}
		
		this.node.position.set( 
			tilePos.x*ggj.tileSize*(1-inter) + nextPos.x*ggj.tileSize*inter, 
			Math.sin(Math.PI*inter)*ggj.tileSize*0.5, 
			tilePos.y*ggj.tileSize*(1-inter) + nextPos.y*ggj.tileSize*inter 
			);
	};
},

Enemy:function()
{
	var enemyType = ggj.enemyTypes[ Math.floor(Math.random()*ggj.enemyTypes.length) ];
	var THIS=this;
	ggj.enemies.push(this);
	var node = this.node = new window[enemyType+"json"].create();
	var world = this.world = ggj.worlds[ Math.floor(Math.random()*ggj.worlds.length) ];
	world.add(this);
	node.controller = this;
	var tilePos = this.tilePos = null;
	
	var falling = true;
	var fallSpeed = 0;
	var targetScale = 1;
	var inter = 0;
	var state = null;
	
	if( enemyType == "bird" )
	{
		this.maxHealth = this.health = 5;
		this.maxStamina = this.stamina = 7;
		this.damage = 2;
	}else if( enemyType == "bones" )
	{
		this.maxHealth = this.health = 7;
		this.maxStamina = this.stamina = 4;
		this.damage = 2;
	}else if( enemyType == "bones2" )
	{
		this.maxHealth = this.health = 9;
		this.maxStamina = this.stamina = 6;
		this.damage = 3;
	}else if( enemyType == "labatut" )
	{
		this.maxHealth = this.health = 15;
		this.maxStamina = this.stamina = 15;
		this.damage = 4;
	}
	
	var tmp = {x:0,y:0};
	var nextPos = {x:0,y:0};
	var isHitting = false;
	
	this.hit = function(dmg)
	{
		this.health -= dmg;
		if( this.health > 0 )
			return;
		new Audio("snd/die" + enemyType + ".wav").play();
		var pos = ggj.enemies.indexOf(this);
		ggj.enemies.splice(pos, 1);
		world.remove(this);
	};
	
	this.play = function()
	{
		ggj.activeEnemy = this;
		motor.gfx.camera.target = this.node;
	};
	
	this.stop = function()
	{
		ggj.activeEnemy = null;
		main.next();
	};
	
	this.onTick = function(time)
	{
		if( falling )
		{
			if( tilePos == null )
			{
				this.tilePos = tilePos = world.getEmptyTile();
				node.position.set( tilePos.x*ggj.tileSize, 500, tilePos.y*ggj.tileSize );
				node.rotation.y = Math.random()*Math.PI*2;				
			}
			if( node.position.y > 0 )
			{
				fallSpeed += time * 10;
				node.position.y -= fallSpeed;
			}
			if( node.position.y < 0 )
			{
				node.position.y = 0;
				falling = false;
			}
			
			return;
		}

		node.scale.y += (targetScale - node.scale.y) * time * 20;
		
		if( ggj.activeEnemy != this )
			return;
		
		if( this.stamina <= 0 )
			return this.stop();
		
		if( !state )
		{
			ggj.activeEnemy = null;
			if( this.stamina <= 0 )
				return this.stop();
			
			var chosen = null;
			var chosenDist = 0xFFFFFFFF;
			for( var k in ggj.players )
			{
				var target = ggj.players[k];
				if( !target.tilePos )
					continue;
				tmp.x = tilePos.x - target.tilePos.x;
				tmp.y = tilePos.y - target.tilePos.y;
				tmp.x = tmp.x * tmp.x;
				tmp.y = tmp.y * tmp.y;
				if( tmp.x+tmp.y < chosenDist )
				{
					chosenDist = tmp.x+tmp.y;
					chosen = target;
				}
			}
			
			if( !chosen ) 
				return this.stop();
			
			if( chosen.tilePos.x != tilePos.x )
				state = {x:Math.sign(chosen.tilePos.x-tilePos.x), y:0};
			else if( chosen.tilePos.y != tilePos.y )
				state = {x:0, y:Math.sign(chosen.tilePos.y-tilePos.y)};
			else {
				return this.stop();
			}
			
			nextPos.y = state.y + tilePos.y;
			nextPos.x = state.x + tilePos.x;
			node.rotation.y = Math.atan2(state.x, state.y);
			
			var tileContent = world.getTileContents( nextPos );
			
			if( tileContent == chosen )
				isHitting = chosen;
			
			if( tileContent !== undefined && !isHitting )
			{
				state = null;
				return this.stop();
			}
			ggj.activeEnemy = this;
			inter = 0;
			this.stamina--;
		}
		
		inter += time * 4;
		
		var isReturn = inter > 0.5 && isHitting;
		
		if( inter > 1 )
		{
			inter = 1;
			state = null;
			if( !isHitting )
			{
				tilePos.x = nextPos.x;
				tilePos.y = nextPos.y;
			}
			else
			{
				isHitting.hit(this.damage);
				new Audio("snd/bite.wav").play();
			}
			targetScale = 1;
			isHitting = false;
		}
		
		if( isReturn ) inter=1-inter;
		this.node.position.set( 
			tilePos.x*ggj.tileSize*(1-inter) + nextPos.x*ggj.tileSize*inter, 
			Math.sin(Math.PI*inter)*ggj.tileSize*0.5, 
			tilePos.y*ggj.tileSize*(1-inter) + nextPos.y*ggj.tileSize*inter 
			);
		if( isReturn ) inter=1-inter;
	};
},

Main:function()
{
	document.getElementById("loading").style.display = "none";
	document.getElementById("hud").style.display = "inline";
	window.main = this;
	motor.gfx.renderer.setClearColor(0); // 0xA0AAFF)
	motor.gfx.camera.position.set(800, 200, 0);
	motor.gfx.camera.setLookAt( new THREE.Vector3(800,0,1000))
	motor.gfx.camera.fov = 30;
	motor.gfx.camera.minY = 100;	
	
	var light = new THREE.AmbientLight(0xAAAAAA, 1);
	motor.gfx.scene.add(light);
	
	light = new THREE.DirectionalLight( 0xDDDDDD, 1 );
	light.position.set( 1,1,1 ).normalize();
	motor.gfx.scene.add(light);

	this.worlds = [];
	new ggj.World("map").activate();
	
	var chars = [
	"old",
	"female",
	"chainsaw"
	];
	
	var objectives =
	[
	"bob"
	];

	var waveNumber = 3;
	var isPlayerTurn = true;
	this.next = function(){
		for( var p in ggj.players )
		{
			var player = ggj.players[p];
			if( player.stamina < player.maxStamina )
			{
				player.stamina++;
				if( player.health < player.maxHealth )
					player.health++;
			}
		}
		for( var k=0, p; p=ggj.enemies[k]; ++k )
		{
			if( p.stamina < p.maxStamina )
				p.stamina++;
			if( p.health < p.maxHealth )
				p.health++;
		}
		
		isPlayerTurn = !isPlayerTurn;
		if( isPlayerTurn )
		{
			if( ggj.activePlayer )
				ggj.activePlayer.activate();
			else
			{
				var p = Object.keys(ggj.players);
				if( p.length )
					ggj.players[ p[ Math.floor(p.length*Math.random()) ] ].activate();
			}
		}
		else
		{
			if( ggj.enemies.length )
				ggj.enemies[ Math.floor(Math.random()*ggj.enemies.length) ].play();
			else{
				waveNumber++;
				var ec = Math.floor((waveNumber+5)/2);
				console.log("Adding " + ec + " new enemies");
				for( var i=0; i<ec; ++i )
					new ggj.Enemy();
			}
		}
	};
	
	var idbox = document.getElementById("idbox");
	idbox.addEventListener("change", function(e){
		var x = parseInt(idbox.value.replace(/[^0-9]|^0/g, "")); // %255;
		if( isNaN(x) ) 
			return;
		
		if( !ggj.players[x] )
		{
			var y = x^197;		
			var charid = (y >> 4) & 0xF
			var objid = y^0xF;
			new ggj.Player(x, window[chars[charid%chars.length]+"json"], objectives[objid%objectives.length], chars[charid%chars.length] );
		}
		idbox.blur();
		ggj.players[x].activate();
	});
	
	var raycaster = new THREE.Raycaster();
	motor.gfx.renderer.domElement.addEventListener("click", function(event){
		event.preventDefault();
		if( !ggj.activePlayer )
			return;
		var vector = new THREE.Vector3();
		vector.set( ( event.clientX / window.innerWidth ) * 2 - 1, - ( event.clientY / window.innerHeight ) * 2 + 1, 0.5 );
		vector.unproject( motor.gfx.camera );

		raycaster.ray.set( motor.gfx.camera.position, vector.sub( motor.gfx.camera.position ).normalize() );

		var intersects = raycaster.intersectObjects( motor.gfx.scene.children, true );
		if( intersects.length )
		{
			var target = intersects.shift().object;
			if( target.controller )
				ggj.activePlayer.attack( target.controller );
		}
	});
	
	document.body.addEventListener("keydown", function(e){
		var id = (e.keyIdentifier || e.key).toLowerCase();
		if( id.match(/[0-9]/) )
			idbox.focus();
		if( id == "u+0043" )
		{
			var cred = document.getElementById("credits");
			if( cred.style.display == "none" )
				cred.style.display = "inline";
			else
				cred.style.display = "none";
		}
		if( e.target.tagName.toLowerCase() == "input" ) return;
		if( ggj.activePlayer )
			ggj.activePlayer.down(id);
	});
	
	document.body.addEventListener("keyup", function(e){
		if( e.target.tagName.toLowerCase() == "input" ) return;
		if( ggj.activePlayer )
			ggj.activePlayer.up((e.keyIdentifier || e.key).toLowerCase());
	});	
	
	this.encode = function( charid, objid )
	{
		return (((charid << 4) & 0xF0 ) | (objid & 0xF)) ^ 197;
	};
}

}
