this.dependencies = this.dependencies || [];

(function(){
var queueSize = 1;
var parseQueue = [];
function load(url, name)
{
	queueSize++;
	name = name || url.split("/").pop().replace(".", "");
	if( url.match(/.*\.js$/) )
	{
		var se = document.createElement("script");
		se.addEventListener("load", popQueue.bind(null, url));
		se.src = url;
		document.head.appendChild( se );
	}
	else if( url.match(/\.png$|\.jpg$/i) )
	{
		var ie = document.createElement("img");
		ie.addEventListener("load", function(){
			window[name] = ie;
			popQueue(url);
		});
		ie.src = url;
		document.head.appendChild( ie );
	}
	else
	{
		var request = new XMLHttpRequest();
		request.open("GET", url, true);
		request.onreadystatechange = function() {//Call a function when the state changes.
			if (request.readyState == 4) {
				if (request.status == 200 || request.status == 0) {
					var data = request.responseText;
					if( url.match(/.*\.json$/) ) data = JSON.parse(data);
					if( url.match(/vxl/) )
					{
						parseQueue.push((function(name, data){
							window[name] = new VoxelMesh(data).getMesh();
						}).bind(null, name, data));
					}
					window[name] = data;
					popQueue(name);
				}
			}
		}
		request.send();		
	}
}

function popQueue(url)
{
	queueSize--;
	if( url ) console.log("loaded " + url);
	if( queueSize==0 )
		new Motor();
}

window.addEventListener("load", function(){
	dependencies.forEach(function(url){ load(url); });
	popQueue();
});

function Gfx()
{
	function Camera(gfx)
	{
		var THIS = this;
		THREE.PerspectiveCamera.call( this, 45, window.innerWidth / window.innerHeight, 10, 100000 );
		
		THIS.setSize = function( w, h )
		{
			THIS.aspect = w / h;
		};
		
		var tmp = new THREE.Vector3(0,0,0);
		function onTick( time )
		{
			if( !THIS.target ) return;
			var tp = THIS.target.position;
			lookAt.x += (tp.x - lookAt.x) * time;
			lookAt.y += (tp.y - lookAt.y) * time;
			lookAt.z += (tp.z - lookAt.z) * time;
			
			THIS.lookAt(lookAt);
			
			tmp.subVectors(THIS.position, tp).normalize()
			tmp.z-=0.5;
			tmp.normalize();
			tmp.multiplyScalar(300).add(tp);
			THIS.position.x += (tmp.x - THIS.position.x) * time;
			THIS.position.y += (tmp.y - THIS.position.y) * time;
			THIS.position.z += (tmp.z - THIS.position.z) * time;
			
			if( THIS.minY !== undefined && THIS.position.y < THIS.minY )
				THIS.position.y = THIS.minY;
		}
		
		var lookAt = new THREE.Vector3(0,0,0);
		this.setLookAt = function( v )
		{
			lookAt.x=v.x;
			lookAt.y=v.y;
			lookAt.z=v.z;
			this.lookAt(v);
		};
		this.up = new THREE.Vector3(0,1,0);
		this.target = null;
		
		gfx.addTick(onTick);
	}
	Camera.prototype = Object.create(THREE.PerspectiveCamera.prototype);
	
	var THIS = this;
	THIS.aoOn = false;
	// workaround for chrome bug: http://code.google.com/p/chromium/issues/detail?id=35980#c12
	if ( window.innerWidth === 0 ) { window.innerWidth = parent.innerWidth; window.innerHeight = parent.innerHeight; }
	THIS.screenWidth = window.innerWidth;
	THIS.screenHeight = window.innerHeight;

	var renderer = THIS.renderer = new THREE.WebGLRenderer();
	THIS.scene = new THREE.Scene();
	THIS.root = new THREE.Object3D();
	THIS.scene.add( THIS.root );
	
	// var depthMaterial, depthTarget, composer;
	renderer.setSize( window.innerWidth, window.innerHeight );
	document.body.appendChild( renderer.domElement );
	var tickers = [];
	THIS.addTick = function( f ){ 
		tickers.push(f); 
		};
	THIS.removeTick = function( f ){ 
		var i=tickers.indexOf(f); 
		if( i==-1 ) return;
		tickers[i] = tickers[tickers.length-1];
		tickers.pop();
	};
	
	var camera = THIS.camera = new Camera(this);
	
	function onResize()
	{
		THIS.screenWidth = window.innerWidth;
		THIS.screenHeight = window.innerHeight;
		camera.setSize( window.innerWidth, window.innerHeight );
		camera.updateProjectionMatrix();
		renderer.setSize( window.innerWidth, window.innerHeight );
	}
	
	window.addEventListener( 'resize', onResize, false );
	/* * /
	// depth
	var depthShader = THREE.ShaderLib[ "depthRGBA" ];
	var depthUniforms = THREE.UniformsUtils.clone( depthShader.uniforms );

	depthMaterial = new THREE.ShaderMaterial( { fragmentShader: depthShader.fragmentShader, vertexShader: depthShader.vertexShader, uniforms: depthUniforms } );
	depthMaterial.blending = THREE.NoBlending;

	// postprocessing
	
	composer = new THREE.EffectComposer( renderer );
	composer.addPass( new THREE.RenderPass( THIS.scene, camera ) );

	depthTarget = new THREE.WebGLRenderTarget( window.innerWidth, window.innerHeight, { minFilter: THREE.NearestFilter, magFilter: THREE.NearestFilter, format: THREE.RGBAFormat } );
	
	var effect = new THREE.ShaderPass( THREE.SSAOShader );
	effect.uniforms[ 'tDepth' ].value = depthTarget;
	effect.uniforms[ 'size' ].value.set( window.innerWidth, window.innerHeight );
	effect.uniforms[ 'cameraNear' ].value = camera.near;
	effect.uniforms[ 'cameraFar' ].value = camera.far;
	
	effect.renderToScreen = true;
	composer.addPass( effect );
	/* */
	var prevTime = performance.now();
	onTick();
	THIS.fps = 0;
	THIS["speed limit"] = false;
	var skipframe = 0;
	function onTick() 
	{
		requestAnimationFrame( onTick );
		if( skipframe )
		{
			skipframe--;
			return;
		}
		else if( THIS["speed limit"] )
			skipframe = 3;
		
		var timer = performance.now();
		var delta = (timer - prevTime) / 1000;
		prevTime = timer;
		if( delta > 1 ) delta = 1;
		for( var i=0; i<tickers.length; ++i )
			tickers[i](delta);
		
		THIS.fps = Math.round(1/delta);
		
		if( THIS.aoOn )
		{
			/*
			effect.uniforms[ 'seed' ].value = Math.random() + 1;
			THIS.scene.overrideMaterial = depthMaterial;
			renderer.render( THIS.scene, camera, depthTarget );

			THIS.scene.overrideMaterial = null;
			composer.render();
			*/
		}
		else
		{
			renderer.render( THIS.scene, camera );
		}
	}	
}


function Motor()
{
	window.motor = this;
	this.gfx = new Gfx();
	parseQueue.forEach(function(f){ f(); });
	setTimeout(function(){ new ggj.Main(); }, 3000);
}

})();